function varargout=plotmesh(self,varargin)
  %
%    d=log(size(me,1))/log(2); % 2^d
%    dim=size(q,1);
%    assert(ismember(d,0:3));
%    assert(ismember(dim,1:3));
  if self.d>3, error('Unable to plot in dimension > 3!');end
  if fc_tools.comp.isOctave()
    varargin=fc_tools.utils.deleteCellOptions(varargin,{'EdgeAlpha','FaceAlpha'});
  end  
  varargin=fc_tools.graphics.xcolor.set_xcolors_varargin(varargin,[]);
  p = inputParser;
  p.KeepUnmatched=true; 
  p.PartialMatching=false;
  p.addParamValue('color',self.color);
  p.parse(varargin{:});
  
  R=p.Results;
  varargin=fc_tools.utils.deleteCellOptions(varargin,p.Parameters);
% d=0 : point
% d=1 : line
% d=2 : square
% d=3 : cube
  if self.type==0
    h=eval(sprintf('PlotSubTh%dsimp%dD(self,R.color,varargin)',self.m,self.d));
  else
    h=eval(sprintf('PlotSubQh%dorth%dD(self,R.color,varargin)',self.m,self.d));
  end
  if self.d==3 && fc_tools.graphics.is2Dview(),view(3);end 
  set(h,'displayname',self.label)
  if nargout==1,varargout{1}=h;end
end

function h=PlotSubTh3simp3D(self,Color,PlotOptions)
  p = inputParser;
  p.KeepUnmatched=true; 
  p.PartialMatching=false;
  p.addParamValue('EdgeColor',Color);
  p.addParamValue('FaceColor','none');
  p.parse(PlotOptions{:});
  R=p.Results;
  PlotOptions=fc_tools.utils.deleteCellOptions(PlotOptions,p.Parameters);
  if self.order==1
    idx=nchoosek(1:4,3);
  else
    Idx=fc_hypermesh.VerticesIdxSimpRef(self.m,self.order);
    idx=nchoosek(Idx,3);
  end
  ME=[];
  for i=1:size(idx,1) 
    ME=[ME;self.me(idx(i,:),:)'];
  end
   h=patch('Vertices',self.q','Faces',ME,'EdgeColor',R.EdgeColor,'FaceColor',R.FaceColor,PlotOptions{:});
end


function h=PlotSubTh2simp3D(self,Color,PlotOptions)
  p = inputParser;
  p.KeepUnmatched=true; 
  p.PartialMatching=false;
  p.addParamValue('EdgeColor','none');
  p.addParamValue('FaceColor',Color);
  p.parse(PlotOptions{:});
  R=p.Results;
  if strcmp(lower(R.FaceColor),'none') && strcmp(lower(R.EdgeColor),'none')
    if isempty(Color), R.EdgeColor=self.color;else R.EdgeColor=Color;end
  end
  if strcmp(lower(R.EdgeColor),'none'), R.EdgeColor='k';end  
  PlotOptions=fc_tools.utils.deleteCellOptions(PlotOptions,p.Parameters);
  q=self.q;
  idx=fc_hypermesh.VerticesIdxSimpRef(self.m,self.order);
  h=trimesh(self.me(idx,:)',q(1,:),q(2,:),q(3,:),'EdgeColor',R.EdgeColor,'faceColor',R.FaceColor,PlotOptions{:});
%    Q=[0 0 0;1 0 0;0 1 0];ME=[1 2 3];
%    h1=trimesh(ME,Q(:,1),Q(:,2),Q(:,3),'EdgeColor','k','faceColor',Color,PlotOptions{:},'Visible','Off');
end

function h=PlotSubTh1simp3D(self,Color,PlotOptions)
  X=[self.q(1,self.me(1,:));self.q(1,self.me(end,:))];
  Y=[self.q(2,self.me(1,:));self.q(2,self.me(end,:))];
  Z=[self.q(3,self.me(1,:));self.q(3,self.me(end,:))];
  H=line(X,Y,Z,'Color',Color,PlotOptions{:});
  h=H(1);
end

function h=PlotSubTh0simp3D(self,Color,PlotOptions)
  %h=plot3(self.q(1),self.q(2),self.q(3),'LineStyle','none','Marker','o','MarkerFaceColor',Color','Color',Color,PlotOptions{:});
  h=scatter3(self.q(1),self.q(2),self.q(3),40,Color,'filled',PlotOptions{:});
end

function h=PlotSubTh2simp2D(self,Color,PlotOptions)
  h=triplot(self.me(self.vidx,:)',self.q(1,:)',self.q(2,:)','Color',Color,PlotOptions{:});
end

function h=PlotSubTh1simp2D(self,Color,PlotOptions)
  X=[self.q(1,self.me(1,:));self.q(1,self.me(end,:))];
  Y=[self.q(2,self.me(1,:));self.q(2,self.me(end,:))];
  H=line(X,Y,'Color',Color,PlotOptions{:});
  h=H(1);
end

function h=PlotSubTh0simp2D(self,Color,PlotOptions)
  %h=plot(self.q(1),self.q(2),'LineStyle','none','Marker','o','MarkerFaceColor',Color','Color',Color,PlotOptions{:});
  % Use scatter to prevent bug with legend when using plot
  h=scatter(self.q(1),self.q(2),40,Color,'filled',PlotOptions{:});
end

function h=PlotSubTh1simp1D(self,Color,PlotOptions)
  X=[self.q(1,self.me(1,:));self.q(1,self.me(end,:))];
  h=line(X,zeros(2,self.nme),'Color',Color,PlotOptions{:});
end

function h=PlotSubTh0simp1D(self,Color,PlotOptions)
  %h=plot(self.q(1),0,'LineStyle','none','Marker','o','MarkerFaceColor',Color','Color',Color,PlotOptions{:});
  h=scatter(self.q(1),0,40,Color,'filled',PlotOptions{:});
end

function h=PlotSubQh3orth3D(self,color,PlotOptions)
  p = inputParser;
  p.KeepUnmatched=true; 
  p.PartialMatching=false;
  p.addParamValue('EdgeColor',color);
  p.addParamValue('FaceColor','none');
  p.parse(PlotOptions{:});
  R=p.Results;
  PlotOptions=fc_tools.utils.deleteCellOptions(PlotOptions,p.Parameters);
  idxFace=[1,2,4,3;5,6,8,7;1,3,7,5;2,4,8,6;1,2,6,5;3,4,8,7];
  if self.order>1
    Idx=fc_hypermesh.VerticesIdxHypRef(self.m,self.order);
    idxFace=Idx(idxFace);
  end
  ME=[];
  for i=1:size(idxFace,1) 
    ME=[ME;self.me(idxFace(i,:),:)'];
  end
  h=patch('Vertices',self.q','Faces',ME,'EdgeColor',R.EdgeColor,'FaceColor',R.FaceColor,PlotOptions{:});
end

function h=PlotSubQh2orth3D(self,color,PlotOptions)
  p = inputParser;
  p.KeepUnmatched=true; 
  p.PartialMatching=false;
  p.addParamValue('EdgeColor','none');
  p.addParamValue('FaceColor',color);
  p.parse(PlotOptions{:});
  R=p.Results;
  if strcmp(lower(R.FaceColor),'none') && strcmp(lower(R.EdgeColor),'none')
    if isempty(color), R.EdgeColor=self.color;else R.EdgeColor=color;end
  end
  if strcmp(lower(R.EdgeColor),'none'), R.EdgeColor='k';end 
  PlotOptions=fc_tools.utils.deleteCellOptions(PlotOptions,p.Parameters);
  idxFace=[1,2,4,3];
  if self.order>1
    Idx=fc_hypermesh.VerticesIdxHypRef(self.m,self.order);
    idxFace=Idx(idxFace);
  end
  h=patch('Vertices',self.q','Faces',self.me(idxFace,:)','EdgeColor',R.EdgeColor,'FaceColor',R.FaceColor,PlotOptions{:});
end

function h=PlotSubQh1orth3D(self,color,PlotOptions)
  X=[self.q(1,self.me(1,:));self.q(1,self.me(end,:))];
  Y=[self.q(2,self.me(1,:));self.q(2,self.me(end,:))];
  Z=[self.q(3,self.me(1,:));self.q(3,self.me(end,:))];
  h=line(X,Y,Z,'Color',color,PlotOptions{:});
  h=h(1);
end


function h=PlotSubQh2orth2D(self,color,PlotOptions)
  p = inputParser;
  p.KeepUnmatched=true; 
  p.PartialMatching=false;
  p.addParamValue('EdgeColor',color);
  p.addParamValue('FaceColor','none');
  p.parse(PlotOptions{:});
  R=p.Results;
  PlotOptions=fc_tools.utils.deleteCellOptions(PlotOptions,p.Parameters);
  idxFace=[1,2,4,3];
  if self.order>1
    Idx=fc_hypermesh.VerticesIdxHypRef(self.m,self.order);
    idxFace=Idx(idxFace);
  end
  h=patch('Vertices',self.q','Faces',self.me(idxFace,:)','EdgeColor',R.EdgeColor,'FaceColor',R.FaceColor,PlotOptions{:});
end

function h=PlotSubQh1orth2D(self,Color,PlotOptions)
  X=[self.q(1,self.me(1,:));self.q(1,self.me(end,:))];
  Y=[self.q(2,self.me(1,:));self.q(2,self.me(end,:))];
  H=line(X,Y,'Color',Color,PlotOptions{:}); 
  h=H(1);
end

function h=PlotSubQh0orth3D(self,Color,PlotOptions)
  h=PlotSubTh0simp3D(self,Color,PlotOptions);
end

function h=PlotSubQh0orth2D(self,Color,PlotOptions)
  h=PlotSubTh0simp2D(self,Color,PlotOptions);
end

function h=PlotSubQh1orth1D(self,Color,PlotOptions)
  h=PlotSubTh1simp1D(self,Color,PlotOptions);
end

function h=PlotSubQh0orth1D(self,Color,PlotOptions)
  h=PlotSubTh0simp1D(self,Color,PlotOptions);
end
