function allbenchs(varargin)
  % run all benchs of the paper:
  %  fc_hypermesh.allbenchs('small',false)
  p = inputParser;
  p.PartialMatching=false;
  p.addParamValue('small', true );
  p.parse(varargin{:});
  R=p.Results;

  printfun=@(dim,type,order) fprintf('***\n*** BENCH : dim=%d, type=''%s'', order=%d\n***\n',dim,type,order);
  bboxfun=@(dim) repmat([-1,1],dim,1);
  Types={'orthotope','simplex'};

  % params{order,dim-1}
  if R.small
    params{1,1}=300:50:500;
    params{1,2}=20:10:60;
    params{1,3}=3:2:11;
    params{1,4}=3:8;
    params{2,1}=100:25:250;
    params{2,2}=20:10:60;
    params{2,3}=3:2:11;
    params{2,4}=2:6;
    params{3,1}=30:10:80;
    params{3,2}=10:10:50;
    params{3,3}=[3:3:12];
    params{3,4}=1:5;
  else
    params{1,1}=1000:1000:5000;
    params{1,2}=40:20:180;
    params{1,3}=[10,20:5:40];
    params{1,4}=2:2:12;
    params{2,1}=1000:1000:5000;
    params{2,2}=40:20:180;
    params{2,3}=[10,20:5:40];
    params{2,4}=2:2:12;
    params{3,1}=[500,1000,2000,3000,4000];
    params{3,2}=40:20:140;
    params{3,3}=[5,10,20:5:30];
    params{3,4}=[3,5,7,9,10];
  end

  for i=1:2
    type=Types{i};
    for order=1:3
      for dim=2:5
        printfun(dim,type,order)
        fc_hypermesh.bench(dim, params{order,dim-1},'type',type,'box',bboxfun(dim),'order',order)
      end
    end
  end
end
